import React, { Component } from 'react';

window.state = {
  keys:[],
  update(key) {
    this.keys[key].forEach(update => { update() });
  }
}

export default class Store {
  constructor(data) {
    this.key = Math.random().toString(36).substr(2, 9);
    this.handler = this.handler.bind(this);
    this.observer = this.observer.bind(this);
    this.data = new Proxy(data, this.handler(this.key));
  }
  handler(key) {
    return {
      set(target, property, value) {
          if(property === "children" || property === "length") {
            return true;
          } else {
            target[property] = value;
            window.state.update(key);
            return true;
          }
        },
      get(target, property) {
        let out = target[property];
        if (out instanceof Object) {
           return new Proxy(out, this);
        }
        return out;
      }
    }
  }
  observer(component) {
    let key = this.key,
        data = this.data;
    return class Observe extends Component {
      constructor() {
        super();
        this.state = data
      }
      updateState() {
        this.setState(data);
      }
      componentDidMount() {
         if(!window.state.keys[key])
             window.state.keys[key] = [];
             window.state.keys[key].push(this.updateState.bind(this));
      }
      render() {
        return React.createElement(component, this.state );
      }
    }
  }
}
